/*	Boxworl2.C by Lionel Baboud
	The Casio Site: http://perso.wanadoo.fr/duobab/
	e-mail: roland.baboud@wanadoo.fr
	------------------------------
	this prog was compiled with TurboC 2.01 and TASM 4.1
*/

#include <stdio.h>
#include <conio.h>
#include <dos.h>
#define tab(a,b,c) map[a][b]=c
#define nlev 35
#define SEG 0x1A20
#define DEC 24

int decx,decy;

char pics[][8][8]=
	{   {{1,1,1,0,1,1,1,0}, /*mur*/
		{1,1,1,0,1,1,1,0},
		{1,1,1,0,1,1,1,0},
		{0,0,0,0,0,0,0,0},
		{1,1,1,1,1,1,1,0},
		{1,1,1,1,1,1,1,0},
		{1,1,1,1,1,1,1,0},
		{0,0,0,0,0,0,0,0}},

	    {{1,1,1,0,1,1,1,1}, /*mur2*/
		{1,1,1,0,1,1,1,1},
		{1,1,1,0,1,1,1,1},
		{0,0,0,0,0,0,0,0},
		{1,1,1,1,1,1,1,0},
		{1,1,1,1,1,1,1,0},
		{1,1,1,1,1,1,1,0},
		{0,0,0,0,0,0,0,0}},

	    {{0,0,0,0,0,0,0,0}, /*vide*/
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}},

	    {{0,0,0,0,0,0,0,0}, /*emplacement*/
		{0,0,1,1,1,0,0,0},
		{0,1,0,1,1,1,0,0},
		{0,1,1,1,1,1,0,0},
		{0,1,1,1,1,1,0,0},
		{0,0,1,1,1,0,0,0},
		{0,0,0,0,0,0,0,0},
		{0,0,0,0,0,0,0,0}},

	    {{1,1,1,1,1,1,1,0}, /*caisse*/
		{1,1,0,0,0,1,1,0},
		{1,0,1,0,1,0,1,0},
		{1,0,0,1,0,0,1,0},
		{1,0,1,0,1,0,1,0},
		{1,1,0,0,0,1,1,0},
		{1,1,1,1,1,1,1,0},
		{0,0,0,0,0,0,0,0}},

	    {{1,1,1,1,1,1,1,0}, /*caisse pleine*/
		{1,0,1,1,1,0,1,0},
		{1,1,0,1,0,1,1,0},
		{1,1,1,0,1,1,1,0},
		{1,1,0,1,0,1,1,0},
		{1,0,1,1,1,0,1,0},
		{1,1,1,1,1,1,1,0},
		{0,0,0,0,0,0,0,0}}};

char perso[][7][7]=
	{   {{0,0,1,1,1,0,0}, /*1*/
		{0,1,1,1,1,1,0},
		{1,1,0,1,0,1,1},
		{1,1,1,1,1,1,1},
		{1,0,1,1,1,0,1},
		{0,1,0,0,0,1,0},
		{0,0,1,1,1,0,0}},

	   {{0,0,1,1,1,0,0}, /*2*/
		{0,1,1,1,1,1,0},
		{1,1,1,0,1,0,1},
		{1,1,1,1,1,1,1},
		{1,1,0,1,1,1,0},
		{0,1,1,0,0,0,0},
		{0,0,1,1,1,0,0}},

	   {{0,0,1,1,1,0,0}, /*3*/
		{0,1,1,1,1,1,0},
		{1,1,1,1,0,1,1},
		{1,1,1,1,1,1,1},
		{1,1,1,0,1,1,1},
		{0,1,1,1,0,0,0},
		{0,0,1,1,1,0,0}},

	   {{0,0,1,1,1,0,0}, /*4*/
		{0,1,1,1,1,1,0},
		{1,1,1,1,1,0,1},
		{1,1,1,1,1,1,1},
		{1,1,1,1,0,1,1},
		{0,1,1,1,1,0,0},
		{0,0,1,1,1,0,0}},

	   {{0,0,1,1,1,0,0}, /*5*/
		{0,1,1,1,1,1,0},
		{1,1,1,1,1,1,0},
		{1,1,1,1,1,1,1},
		{1,1,1,1,1,1,0},
		{0,1,1,1,1,1,0},
		{0,0,1,1,1,0,0}},

	   {{0,0,1,1,1,0,0}, /*6*/
		{0,1,1,1,1,1,0},
		{1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1},
		{1,1,1,1,1,1,1},
		{0,1,1,1,1,1,0},
		{0,0,1,1,1,0,0}}};

void setPix(unsigned short int x, unsigned short int y,unsigned int segm,char state)
	{asm push ax;
	asm push cx;
	asm push dx;
	asm mov cx,x;
	asm mov dx,y;
	asm mov es,segm;
	asm mov al,state;
	asm mov si,0x003f;
	asm sub si,dx;
	asm sub cx,0x80;
	asm not cx;
	asm push cx;
	asm and cl,0xf8;
	asm shl cx,0x03;
	asm add si,cx;
	asm pop cx;
	asm and cl,0x07;
	asm mov ah,0xfe;
	asm rol ah,cl;
	asm and es:[si],ah;
	asm mov ah,al;
	asm rol ah,cl;
	asm or es:[si],ah;
	asm pop dx;
	asm pop cx;
	asm pop ax;}

char trns(char i)
	{int v=i;
	if (i==8) v=0;
	if (i==9) v=1;
	if (i==0) v=2;
	if (i==1) v=3;
	if (i==2) v=4;
	if (i==3) v=5;
	return v;}

void drawCase(int m,int n,int c)
	{int i,j,k;
	k=trns(c);
	for (i=0;i<8;i++)
		for (j=0;j<8;j++)
			setPix(decx+8*n+j-8,8*m+i-8+decy,SEG,pics[k][i][j]);}

void drawPerso(int m,int n,int t)
	{int i,j;int k=t;int inv=0;
	if (t==6 || t==7) k=5;
	if (t>7) {k=12-t;inv=1;}
	if (inv==0)
	{for (i=0;i<7;i++) for (j=0;j<7;j++)
		setPix(decx+8*n+j-8,8*m+i-8+decy,SEG,perso[k][i][j]);}
	else {for (i=0;i<7;i++) for (j=0;j<7;j++)
		setPix(decx+8*n+j-8,8*m+i-8+decy,SEG,perso[k][i][6-j]);}}

void hline(int x1,int x2,int y)
	{int i;
	for(i=x1;i<=x2;i++) setPix(i,y,SEG,1);}

void vline(int x,int y1,int y2)
	{int i;
	for(i=y1;i<=y2;i++) setPix(x,i,SEG,1);}

void rect(int x1,int y1,int x2,int y2)
	{hline(x1,x2,y1);
	hline(x1,x2,y2);
	vline(x1,y1,y2);
	vline(x2,y1,y2);}

void fillRect(int x1,int y1,int x2,int y2,char state)
	{int i,j;
	for(i=x1;i<=x2;i++)
		for(j=y1;j<=y2;j++)
			setPix(i,j,SEG,state);}

void drawCadre(x1,y1,x2,y2)
	{rect(x1,y1,x2,y2);
	hline(x1+1,x2+1,y2+1);
	vline(x2+1,y1+1,y2+1);}

void fillCadre(int x1,int y1,int x2,int y2)
	{int a1=6*(x1-1)-2;
	int b1=8*(y1-1)-2;
	int a2=6*x2+1;
	int b2=8*y2+1;
	fillRect(a1-1,b1-1,a2+2,b2+2,0);
	drawCadre(a1,b1,a2,b2);}

void underline(x1,x2,y) {hline(6*(x1-1)-1,6*x2+1,8*y+1);}

void clrgfx()
	{asm push ax;
	asm mov ax,0x0000;
	asm	int 10h;
	asm pop ax;}

int waitkey()
	{int v=getch();
	if (v==0) v=getch();
	return v;}

int getDix() 
	{struct time temps;
	gettime(&temps);
	return (100*temps.ti_sec+temps.ti_hund)/25;}

int getSecs() 
	{struct time temps;
	gettime(&temps);
	return (temps.ti_sec+60*temps.ti_min+3600*temps.ti_hour);}

void locate(int x,int y,char st[])
	{gotoxy(x,y);
	printf(st);}

char tabs[][120]=
	{"000000000000000099999900009990000900099102990990091120200690091102020990099999900900000000999900000000000000000000000000",
	"009999999990009009900090009000200090009209990290009091119090099091119099090200200209090000090609099999999999000000000000",
	"000000000000000099999000009990069900009002100900009001210900009990320900000090009900000099999000000000000000000000000000",
	"000000000000000000000000099990099999990090090009902099992009900211110209990000906099099999999990000000000000000000000000",
	"000000000000009999000000009609990000009000099900009092001900009020211900009020199900009009990000009999000000000000000000",
	"000000000000000099999000009990069990099020900090090200020090090909920990091111000900099999999900000000000000000000000000",
	"000000000000009999999900009009000900009021120900009621309900009021120900009009000900009999999900000000000000000000000000",
	"000000000000000999999900009900000990009020220090009111111990009022020900009990699900000099990000000000000000000000000000",
	"000999999000000900009990000902000090099902099090091110200090091112920990099990902090000090060090000099999990000000000000",
	"000000000000009999990000009000090000009022299000009009119990009900112090000906000090000999999990000000000000000000000000",
	"000000000000009999999000009111109000099911129990090029202090090220092090090000900090099990609990000099999000000000000000",
	"000000000000009999999000009112119000009119119000009022209000009002009000009022209000009009609000009999999000000000000000",
	"000000000000000099999900000090111900099991111900090099920999090202002209096020200009090009990009099999099999000000000000",
	"000000000000000999990000099900099990090002020090090200020690099922999990000900119000000911119000000999999000000000000000",
	"000000000000009999999900009111111900009002090990009020902090009920202090000900600090000999999990000000000000000000000000",
	"000000000000009999999999999000100009900099299009906210101299990299299090090000100090099999999990000000000000000000000000",
	"000000000000000009999990009999100690009002220090009199199190009000200090009002190990009999000900000009999900000000000000",
	"000000000000000999999000000910119000000910219000009990029900009020020900009092990900009000600900009999999900000000000000",
	"099999999900090009900900090902020900090031900900099091619900099299939990090000000090090009909090099999900090000000999990",
	"000000000000000009999900000009060900000009222900009999000900009000192990009021210190009009191990009999999900000000000000",
	"000000000000000000999990009999900090009011029090009091300090099031920990090200200900090009906900099999999900000000000000",
	"000099999000009990009990099006202090090099099099090219120009090919390009090211100999099929099900000900090000000999990000",
	"000000000000009999999000009001209990009012120090009321216090009012120990009001200900009999999900000000000000000000000000",
	"000099999000000990009999000901130209999909120009900001319699909099299090900000202090990090009990099999999000000000000000",
	"000000000000009999990000009000090000009020099990009023113090009031132090009999002090000009060090000009999990000000000000",
	"000000000000000009999900009999100990009021210090009629092090009021010090009999292090000091010090000099999990000000000000",
	"000000000000000000000000999999999999900001110209902223330269900001110209999999999999000000000000000000000000000000000000",
	"000000000000000000000000099999999990099000000090090009292090090220012190090699911190099999999990000000000000000000000000",
	"000000000000000999999900000910101900000902220900000912621900000902220900000910101900000999999900000000000000000000000000",
	"000099990000999990099999900002000209900292990009999091310999009011106900009909299900000900090000000999990000000000000000",
	"000000000000000099999999099990000109090020202109090019999199090212020690090010099990099999990000000000000000000000000000",
	"000099999000009990609990009002020090009031313090009012021090009031313090009002020090009999990090000000099990000000000000",
	"000000000000000000000000099999000000090009999990090201102090099201122690009001102090009999999990000000000000000000000000",
	"000000000000009999900000009000999999999291000009902011190209960219320009999900009999000999999000000000000000000000000000",
	"000000000000009999999990009000300090009020302090009311333190009062102090009000300090009999999990000000000000000000000000"};

main()
	{int key,m,n,i,j,p,q,p2,q2,m0,n0,tm,t1;
	int ok,lev,bmax,coups,dec1,dec2;
	char level[120];
	char map[10][12];
	m=0;n=0;p=0;q=0;p2=0;q2=0;m0=0;n0=0;

intro:
	clrgfx();
	decx=0;decy=0;
	for(i=1;i<=16;i++) for(j=1;j<=8;j++) drawCase(j,i,9);
	fillCadre(6,2,16,3);
	locate(7,2,"Boxworld2");
	locate(7,3,"by Duobab");
	fillCadre(6,6,16,7);
	locate(6,6,"[F1]:help");
	locate(6,7,"[EXE]:play");
	lev=0;
	key=waitkey();

	if (key==59)
		{clrscr();
		printf("    ");putchar(246);putchar(188);printf(" Boxworld2 ");
		putchar(246);putchar(189);printf("\n");
		printf("      by Duobab\n\n");
		printf("[");putchar(246);putchar(156);printf("][");putchar(246);putchar(158);
		printf("][");putchar(246);putchar(159);printf("][");putchar(246);putchar(157);
		printf("]:move\n");
		printf("[F1]:previous level\n");
		printf("[F2]:next level\n");
		printf("[F3]:init level\n");
		printf("[ESC]:exit");
		waitkey();
		goto intro;}

debut:
	key=0;ok=0;bmax=0;coups=0;
	for(i=0;i<120;i++) level[i]=(tabs[lev][i]-48);
	for (i=0;i<10;i++)
		for (j=0;j<12;j++)
			{int val=level[12*i+j];
			map[i][j]=val;
			if (val==6) {m=i;n=j;tab(m,n,0);}
			if (val==3) ok++;
			if (val==1 || val==3) bmax++;}

	dec1=12;dec2=-1;
	for(i=0;i<10;i++) for(j=0;j<12;j++)
			{if (j<dec1 && map[i][j]!=0) dec1=j;
			if ((11-j)>dec2 && map[i][11-j]!=0) dec2=(11-j);}
	decx=DEC-4*((dec2-dec1+1)%2);
	dec1=10;dec2=-1;
	for(j=0;j<12;j++) for(i=0;i<10;i++) 
			{if (i<dec1 && map[i][j]!=0) dec1=i;
			if ((9-i)>dec2 && map[9-i][j]!=0) dec2=(9-i);}
	decy=(dec2-dec1+1);
	if (decy<=8) decy=4*(decy%2);
		else decy=0;

	clrgfx();
	for(i=1;i<=8;i++) for(j=0;j<12;j++)
		if (map[i][j]!=9) drawCase(i,j,map[i][j]);
			else	if (j<11 && map[i][j+1]==9) drawCase(i,j,9);
				else drawCase(i,j,8);

	t1=getSecs();
	while (!(key==1||key==59||key==60||key==61||ok==bmax))
		{while(!kbhit())
			{tm=getDix()%12;
			drawPerso(m,n,tm);}
		key=waitkey();
		p=m;q=n;
		if (key==72) p--;
		if (key==77) q++;
		if (key==80) p++;
		if (key==75) q--;
		if (map[p][q]!=9)
			{p2=2*p-m;
			q2=2*q-n;
			m0=m;n0=n;
			if (map[p][q]==2)
				{if (map[p2][q2]==0) {tab(p2,q2,2);tab(p,q,0);m=p;n=q;drawCase(p2,q2,map[p2][q2]);coups++;}
				if (map[p2][q2]==1) {ok++;tab(p2,q2,3);tab(p,q,0);m=p;n=q;drawCase(p2,q2,map[p2][q2]);coups++;}}
			if (map[p][q]==3)
				{if (map[p2][q2]==0) {ok--;tab(p2,q2,2);tab(p,q,1);m=p;n=q;drawCase(p2,q2,map[p2][q2]);coups++;}
				if (map[p2][q2]==1) {tab(p2,q2,3);tab(p,q,1);m=p;n=q;drawCase(p2,q2,map[p2][q2]);coups++;}}
			if (map[p][q]<=1) {m=p;n=q;}
			drawCase(m0,n0,map[m0][n0]);
			}
		}
	drawPerso(m,n,0);
	if (key==59) {lev=(nlev+lev-1)%nlev;goto debut;}
	if (key==60) {lev=(lev+1)%nlev;goto debut;}
	if (key==61) goto debut;
	if (ok==bmax) {fillCadre(5,3,16,6);
				locate(6,3,"WELL DONE!");
				gotoxy(7,4);printf("level:%2d",(lev+1));
				gotoxy(7,5);printf("moves:%2d",coups);
				gotoxy(6,6);printf("time:%4d",(getSecs()-t1));
				waitkey();
				lev=(lev+1)%nlev;goto debut;}
	clrscr();
	printf("Boxworld2 by Duobab\n\n");
	printf("The Casio site:    \n");
	printf("  http://          \n");
	printf("  perso.wanadoo.fr \n");
	printf("  /duobab/         \n\n");
	printf("Salut..");
	underline(1,9,1);
	vline(9,28,50);hline(9,59,50);
	waitkey();
	}
